unit WaitUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Menus, ShellAPI;

type
  TfrmWait = class(TForm)
    BitBtn1: TBitBtn;
    Label1: TLabel;
    PopupMenu1: TPopupMenu;
    About1: TMenuItem;
    Exit1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
     procedure WndProc(var Msg : TMessage); override;
    { Private declarations }
  public
//      IconNotifyData : TNotifyIconData;
    { Public declarations }
  end;

var
  frmWait: TfrmWait;

implementation

{$R *.DFM}

// http://www.inquiry.com/techtips/delphi_pro/files/10min0798.htm
// http://www.inprise.com/devsupport/delphi/qanda/FAQ1355D.html
// http://www.inprise.com/devsupport/delphi/qanda/FAQ574D.html

var
  OldWindowProc : Pointer; {Variable for the old windows proc}
  MyMsg : DWord; {custom systemwide message}

function NewWindowProc(WindowHandle : hWnd;
                       TheMessage   : LongInt;
                       ParamW       : LongInt;
                       ParamL       : LongInt) : LongInt stdcall;
begin
  if TheMessage = MyMsg then begin
   {Tell the application to restore, let it restore the form}
    SendMessage(Application.handle, WM_SYSCOMMAND, SC_RESTORE, 0);
    SetForegroundWindow(Application.Handle);
   {We handled the message - we are done}
    Result := 0;
//    ShowMessage('ok');
    Application.Terminate;
//    frmWait.Close;

    exit;
  end;
 {Call the original winproc}
  Result := CallWindowProc(OldWindowProc,
                           WindowHandle,
                           TheMessage,
                           ParamW,
                           ParamL);
end;

procedure TfrmWait.FormCreate(Sender: TObject);
begin
 {Register a custom windows message}
  MyMsg := RegisterWindowMessage('WaitForMe');
 {Set form1's windows proc to ours and remember the old window proc}
  OldWindowProc := Pointer(SetWindowLong(frmWait.Handle,
                                         GWL_WNDPROC,
                                         LongInt(@NewWindowProc)));


  //Set the border icons to have only a system menu. This will
  //leave just the close button.
//  BorderIcons := [biSystemMenu];

  //Now set up the IconNotifyData structure so that it receives
  //the window messages sent to the application and displays
  //the application's tips
{  with IconNotifyData do begin
    hIcon := Application.Icon.Handle;
    uCallbackMessage := WM_USER + 1;
    cbSize := sizeof(IconNotifyData);
    Wnd := Handle;
    uID := 100;
    uFlags := NIF_MESSAGE + NIF_ICON + NIF_TIP;
  end;   }
  //Copy the Application's Title into the tip for the icon
//  StrPCopy(IconNotifyData.szTip, Application.Title);
  //Add the Icon to the system tray and use the
  //the structure and its values
//  Shell_NotifyIcon(NIM_ADD, @IconNotifyData);

//  ShowWindow(Application.Handle, SW_HIDE);

end;

procedure TfrmWait.FormDestroy(Sender: TObject);
begin
  {Set form1's window proc back to it's original procedure}
  SetWindowLong(frmWait.Handle,
                GWL_WNDPROC,
                LongInt(OldWindowProc));
end;

procedure TfrmWait.FormShow(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;

end;

procedure TfrmWait.WndProc(var Msg : TMessage);
var
  p : TPoint;
begin
  case Msg.Msg of
    WM_USER + 1:
    case Msg.lParam of
      WM_RBUTTONDOWN: begin
                        GetCursorPos(p);
                        PopupMenu1.Popup(p.x, p.y);
                      end;
    end;
  end;
  inherited;
end;

procedure TfrmWait.About1Click(Sender: TObject);
begin
  ShowMessage(Label1.Caption);
end;


procedure TfrmWait.Exit1Click(Sender: TObject);
begin
//  Shell_NotifyIcon(NIM_DELETE, @IconNotifyData);
  Application.ProcessMessages;
  Application.Terminate;
end;

procedure TfrmWait.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Exit1Click(Sender);
end;

begin
 {Tell Delphi to hide it's hidden application window for now to avoid}
 {a "flash" on the taskbar if we halt due to another instance}
//  ShowWindow(Application.Handle, SW_HIDE);
//  ShowWindow(Application.Handle, SW_MINIMIZE);

end.
